//////////////////////////////////////////////////////////////////////
/*****************************************************************/
// This file is a part of the E-Form++ MFC Extention Class.
// 2001-200? ucancode.com Software, All Rights Reserved.
// This is only define for UCanCode Software E-Form++ Library.
//
// UCanCode SOFTWARE GRANTS TO YOU (ONE SOFTWARE PROGRAMMER) THE
// LIMITED RIGHT TO USE THIS SOFTWARE ON A SINGLE COMPUTER.  
//  THESE SOURCE FILE ARE CONSIDERED CONFIDENTIONAL AND ARE 
// THE PROPERTY OF UCanCode SOFTWARE AND ARE NOT TO BE RE-DISTRIBUTED
// BY ANY MEANS WHATSOEVER WITHOUT THE EXPRESSED WRITTEN CONSENT OF 
// UCanCode SOFTWARE.
//
// You can contact us.
// Support@ucancode.com
// http://www.ucancode.com
/********************************************************************/
// FOPCloudShape.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "FOPCloudShape.h"
#include <afxpriv.h>
#include "FODrawHelper.h"
#include "FOPathShape.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// CFOPCloudShape Class
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL(CFOPCloudShape, CFODrawPortsShape, 0)
CFOPCloudShape::CFOPCloudShape()
{
	SetType(FOP_CLOUND_SHAPE);
	SetPolyObject(TRUE);

}

CFOPCloudShape::CFOPCloudShape(const CFOPCloudShape& src)
{
	*this = src;
}

CFOPCloudShape::~CFOPCloudShape()
{

}

/////////////////////////////////////////////////////////////////////////////
// CFOPCloudShape diagnostics

#ifdef _DEBUG
void CFOPCloudShape::AssertValid() const
{
	CFODrawPortsShape::AssertValid();
}

void CFOPCloudShape::Dump(CDumpContext& dc) const
{
	CFODrawPortsShape::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////

void CFOPCloudShape::Create(CRect &rcPos,CString strCaption)
{
// Example code:
	FOPBezPoint *pts = new FOPBezPoint[9];
	ComputeCloud(rcPos, pts);
	AllocMemory(25);

	m_lpShapePoints[0] = pts[0].p1;
	int y = 1;
	for( int x = 1; x <= 8; x++)
	{
		m_lpShapePoints[y] = pts[x].p1;
		y++;
		m_lpShapePoints[y] = pts[x].p2;
		y++;
		m_lpShapePoints[y] = pts[x].p3;
		y++;
	}

	delete [] pts;

	CFODrawPortsShape::Create(rcPos,strCaption);
	BuildAllDefaultPorts();
	UpdateComp();

}

void CFOPCloudShape::Serialize(CArchive& ar)
{
	CFODrawPortsShape::Serialize(ar);
	if(ar.IsStoring())
	{
		//FODO:Add your own code here.

	}
	else
	{
		//FODO:Add your own code here.

	}
}

/////////////////////////////////////////////////////////////////////////////
// CPrintBaseJob serialization
CFile* CFOPCloudShape::GetFile(LPCTSTR lpszFileName, UINT nOpenFlags,
								 CFileException* pError)
{
	CMirrorFile* pFile = new CMirrorFile;
	ASSERT(pFile != NULL);
	if (!pFile->Open(lpszFileName, nOpenFlags, pError))
	{
		delete pFile;
		pFile = NULL;
	}
	return pFile;
}

void CFOPCloudShape::ReleaseFile(CFile* pFile, BOOL bAbort)
{
	ASSERT_KINDOF(CFile, pFile);
	if (bAbort)
		pFile->Abort(); // will not throw an exception
	else
		pFile->Close();
	delete pFile;
}

BOOL CFOPCloudShape::OpenDocument(LPCTSTR lpszPathName)
{
	
	CFileException fe;
	CFile* pFile = GetFile(lpszPathName,
		CFile::modeRead|CFile::shareDenyWrite, &fe);
	if (pFile == NULL)
	{
		return FALSE;
	}
	
	CArchive loadArchive(pFile, CArchive::load | CArchive::bNoFlushOnDelete);
	loadArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		if (pFile->GetLength() != 0)
			Serialize(loadArchive);     // load me
		loadArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
		
		return TRUE;
}

BOOL CFOPCloudShape::SaveDocument(LPCTSTR lpszPathName)
{
	
	CFileException fe;
	CFile* pFile = NULL;
	pFile = GetFile(lpszPathName, CFile::modeCreate |
		CFile::modeReadWrite | CFile::shareExclusive, &fe);
	
	if (pFile == NULL)
	{
		
		return FALSE;
	}
	
	CArchive saveArchive(pFile, CArchive::store | CArchive::bNoFlushOnDelete);
	saveArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		Serialize(saveArchive);     // save me
		saveArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
		
		return TRUE;        // success
}


CFOPCloudShape& CFOPCloudShape::operator=(const CFOPCloudShape& src)
{
	(*(CFODrawPortsShape*)this) = src;
	return (*this);
}

CFODrawShape* CFOPCloudShape::Copy() const
{
	return (new CFOPCloudShape(*this));
}

void CFOPCloudShape::PrepareDC(CDC* pDC)
{
	CFODrawPortsShape::PrepareDC(pDC);

	//FODO:Add your own code below.
	
}

void CFOPCloudShape::ComputeCloud(const FOPRect &rcPos, FOPBezPoint* bpl) 
{
     double wd,hd;

	 FOPPoint ptCorner = rcPos.TopLeft();

     wd=rcPos.Width()/4.0;
     hd=rcPos.Height()/4.0;

     bpl[0].p1.x=(int)(ptCorner.x+wd/2.0);
     bpl[0].p1.y=(int)(ptCorner.y+hd);

     bpl[1].p3.x=(int)(bpl[0].p1.x+wd);
     bpl[1].p3.y=(int)(bpl[0].p1.y+2*hd/5.0);
     bpl[1].p1.x=bpl[0].p1.x;
     bpl[1].p1.y=(int)(bpl[0].p1.y-hd*1.6);
     bpl[1].p2.x=bpl[1].p3.x;
     bpl[1].p2.y=(int)(bpl[1].p3.y-hd*1.6);

     bpl[2].p3.x=(int)(bpl[1].p3.x+wd);
     bpl[2].p3.y=(int)(bpl[0].p1.y-hd/5.0);
     bpl[2].p1.x=bpl[1].p3.x;
     bpl[2].p1.y=(int)(bpl[1].p3.y-hd*1.45);
     bpl[2].p2.x=bpl[2].p3.x;
     bpl[2].p2.y=(int)(bpl[2].p3.y-hd*1.45);

     bpl[3].p3.x=(int)(bpl[2].p3.x+wd);
     bpl[3].p3.y=(int)(bpl[0].p1.y+2*hd/5.0);
     bpl[3].p1.x=bpl[2].p3.x;
     bpl[3].p1.y=(int)(bpl[2].p3.y-hd*1.45);
     bpl[3].p2.x=(int)(bpl[3].p3.x+wd/2.0);
     bpl[3].p2.y=(int)(bpl[3].p3.y-hd*1.45);

     bpl[4].p3.x=bpl[3].p3.x;
     bpl[4].p3.y=(int)(bpl[0].p1.y+2*hd);
     bpl[4].p1.x=(int)(bpl[3].p3.x+wd/1.5);
     bpl[4].p1.y=bpl[3].p3.y;
     bpl[4].p2.x=(int)(bpl[4].p3.x+wd/1.5);
     bpl[4].p2.y=bpl[4].p3.y;

     bpl[5].p3.x=(int)(bpl[4].p3.x-wd-wd/5.0);
     bpl[5].p3.y=(int)(bpl[4].p3.y+wd/20.0);
     bpl[5].p1.x=(int)(bpl[4].p3.x+wd/2.0);
     bpl[5].p1.y=(int)(bpl[4].p3.y+hd*1.3);
     bpl[5].p2.x=(int)(bpl[5].p3.x-wd/20.0);
     bpl[5].p2.y=(int)(bpl[5].p3.y+hd*1.3);

     bpl[6].p3.x=(int)(bpl[5].p3.x-wd);
     bpl[6].p3.y=(int)(bpl[4].p3.y+wd/10.0);
     bpl[6].p1.x=bpl[5].p3.x;
     bpl[6].p1.y=(int)(bpl[5].p3.y+hd*1.3);
     bpl[6].p2.x=bpl[6].p3.x;
     bpl[6].p2.y=(int)(bpl[6].p3.y+hd*1.3);

     bpl[7].p3.x=(int)(bpl[6].p3.x-wd+wd/10.0);
     bpl[7].p3.y=(int)(bpl[4].p3.y-wd/5.0);
     bpl[7].p1.x=bpl[6].p3.x;
     bpl[7].p1.y=(int)(bpl[6].p3.y+hd*1.45);
     bpl[7].p2.x=bpl[7].p3.x;
     bpl[7].p2.y=(int)(bpl[7].p3.y+hd*1.45);

     bpl[8].p3.x=bpl[0].p1.x;
     bpl[8].p3.y=bpl[0].p1.y;
     bpl[8].p1.x=(int)(bpl[7].p3.x-wd/1.6);
     bpl[8].p1.y=bpl[7].p3.y;
     bpl[8].p2.x=(int)(bpl[0].p1.x-wd/1.6);
     bpl[8].p2.y=bpl[0].p1.y;
}

void CFOPCloudShape::GetPathSimplePolygon(FOPSimpleCompositePolygon& rPoly) const
{
	rPoly.Clear();

	CPoint ptEnd = m_lpShapePoints[0];
	CPoint ptStart = m_lpShapePoints[m_nCompPtCount -1];
	
	
	int nSize = m_nCompPtCount;
	nSize = (( nSize - 1 )/ 3);
	if(CFODrawHelper::Distance(ptStart,ptEnd) > 10)
	{
		/*CPoint *ptNews = new CPoint[m_nCompPtCount + 3];
	
		int x = 0;
		for(x = 0; x < m_nCompPtCount; x++)
		{
			ptNews[x] = FOPPoint(m_lpShapePoints[x]);
		}
		
		CPoint ptPoints[2];
		CPoint ptTemp = CPoint(CFODrawHelper::RoundValue(ptStart.x + (ptEnd.x - ptStart.x)/4.0),
			CFODrawHelper::RoundValue(ptStart.y + (ptEnd.y - ptStart.y)/4.0));
		ptPoints[0] = ptTemp;
		ptTemp = CPoint(CFODrawHelper::RoundValue(ptStart.x + (ptEnd.x - ptStart.x)*3.0/4.0),
			CFODrawHelper::RoundValue(ptStart.y + (ptEnd.y - ptStart.y)*3.0/4.0));
		ptPoints[1] = ptTemp;
		
		ptNews[x] = ptPoints[0];
		ptNews[x + 1] = ptPoints[1];
		ptNews[x + 2] = ptEnd;
	
		FOPSimplePolygon poly(ptNews,m_nCompPtCount + 2);
		rPoly.Insert(poly);

		delete [] ptNews;
		ptNews = NULL;*/
		FOPSimplePolygon poly(m_lpShapePoints,m_nCompPtCount);
		rPoly.Insert(poly);
	}
	else
	{
		FOPSimplePolygon poly(m_lpShapePoints,m_nCompPtCount);
		rPoly.Insert(poly);
	}
}

void CFOPCloudShape::OnDrawTrackCustom(CDC *pDC)
{
	ASSERT( ( ( m_nCompTrackPtCount - 1 ) % 3 ) == 0 );
	
	pDC->PolyBezier(m_lpShapeTrackPoints, m_nCompTrackPtCount);
	
	// Draw a line between start and end point
	if( ( m_lpShapeTrackPoints[0].x != m_lpShapeTrackPoints[m_nCompTrackPtCount-1].x ) ||
		( m_lpShapeTrackPoints[0].y != m_lpShapeTrackPoints[m_nCompTrackPtCount-1].y ) )
	{
		pDC->MoveTo( m_lpShapeTrackPoints[m_nCompTrackPtCount-1].x, m_lpShapeTrackPoints[m_nCompTrackPtCount-1].y );
		pDC->LineTo( m_lpShapeTrackPoints[0].x, m_lpShapeTrackPoints[0].y );
	}
	
	pDC->EndPath();	
	pDC->StrokeAndFillPath();

	CPoint ptStart;
	if (m_nCompTrackPtCount > 0)
	{
		CPen* pOldPen = pDC->SelectObject(&gfxData.m_penTrack);
		ptStart = m_lpShapeTrackPoints[0];
		pDC->MoveTo(ptStart);
		
		for (int i=0; i<m_nCompTrackPtCount; i++)
		{
			CPoint ptDev = m_lpShapeTrackPoints[i];
			pDC->LineTo(ptDev);
		}
		if(pOldPen != NULL)
		{
			pDC->SelectObject(pOldPen);
		}
	}

	OnDrawTrackPorts(pDC);
}

void CFOPCloudShape::DrawDotBorder(CDC* pDC)
{
	CPen* pOldPen = pDC->SelectObject(&gfxData.m_penTrack);

	pDC->Polyline(m_lpShapePoints, m_nCompPtCount);

	pDC->SelectObject(pOldPen);
	
}

CFODrawShape* CFOPCloudShape::DoConvertToPathObj(CDC *pDC,const BOOL &bBezier)
{
	BOOL bFill = TRUE;
	FOPSimpleCompositePolygon aSimplePoly;
	GetPathSimplePolygon(aSimplePoly);
	CFODrawShape* pRet = ConvertToPathShape(pDC,aSimplePoly, bFill, bBezier);
	if(pRet != NULL)
	{
		if (HAS_BASE(pRet,CFOPathShape))
		{
			CFOPathShape *pPath = static_cast<CFOPathShape *>(pRet);
			pPath->ConvertAllSegments(bBezier ? FOP_PATH_CURVE : FOP_PATH_LINE);
		}
	}
	return pRet;
}

void CFOPCloudShape::DoDrawVisioOrderLine(CDC *pDC)
{
	CPoint ptSpot;

	CArray<CPoint,CPoint> arHandles;
	arHandles.RemoveAll();
	
	DoGenPoints(&arHandles);
	if(IsMainObj())
	{
		for (int i=0; i<arHandles.GetSize(); i++)
		{
			ptSpot = arHandles.GetAt(i);
			pDC->LPtoDP(&ptSpot);
			arHandles.SetAt(i,ptSpot);
		}
		
		DrawMainShapeBorder(pDC,&arHandles,TRUE,TRUE);
	}
	else
	{
		for (int i=0; i<arHandles.GetSize(); i++)
		{
			ptSpot = arHandles.GetAt(i);
			pDC->LPtoDP(&ptSpot);
			arHandles.SetAt(i,ptSpot);
		}
		
		DrawSecondShapeBorder(pDC,&arHandles,TRUE,TRUE);
	}
}

void CFOPCloudShape::OnDrawFlat(CDC *pDC)
{
	CFODrawPortsShape::OnDrawFlat(pDC);

	//FODO:Add your own code below.
	ASSERT( ( ( m_nCompPtCount - 1 ) % 3 ) == 0 );
	
	FillCloseBezier(pDC,m_lpShapePoints, m_nCompPtCount,GetBkColor(),GetPatternColor(),GetBrushType());
	

}

void CFOPCloudShape::OnDrawShadow(CDC *pDC)
{
//	CFODrawPortsShape::OnDrawShadow(pDC);

	//FODO:Add your own code below.
	FillShadowCloseBezier(pDC,m_lpShapePoints,m_nCompPtCount);
}

void CFOPCloudShape::OnDraw3d(CDC *pDC)
{
	CFODrawPortsShape::OnDraw3d(pDC);
	
	ASSERT( ( ( m_nCompPtCount - 1 ) % 3 ) == 0 );
	
	FillCloseBezier(pDC,m_lpShapePoints, m_nCompPtCount,GetBkColor(),GetPatternColor(),GetBrushType());
	

}

void CFOPCloudShape::ClearDC(CDC* pDC)
{
	CFODrawPortsShape::ClearDC(pDC);

	//FODO:Add your own code below.

}

CFOArea CFOPCloudShape::GetBorderArea()
{	
	int nEdgePointCount = m_nCompPtCount;
	LPPOINT lpBorderPoints = new POINT[nEdgePointCount];
	
	for (int i=0; i<m_nCompPtCount; i++)
		lpBorderPoints[i] = m_lpShapePoints[i];
	
	CFOArea area;
	area.BuildArea(lpBorderPoints, nEdgePointCount,CFOArea::AreaBezierLine);
	delete [] lpBorderPoints;

	return area;
}

void CFOPCloudShape::GeometryUpdated(CFOArea* pArea)
{
	if (m_lpShapePoints && pArea)
	{
		pArea->BuildArea(m_lpShapePoints, m_nCompPtCount,CFOArea::AreaCloseBezier);
		m_rectPosition = GetMaxRect();
	}
}
